; STRUCTS START
ResDir STRUCT
	Characteristics dd      ?
	TimeDateStamp dd        ?
	MajorVersion dw         ?
	MinorVersion dw         ?
	NumberOfNamedEntries dw ?
	NumberOfIdEntries dw    ?
ResDir ENDS

ResDirEntry STRUCT
	NameRVA   dd ?
	DataEntry dd ?
ResDirEntry ENDS

ResDataEntry STRUCT
	DataRVA  dd ?
	DataSize dd ?
	CodePage dd ?
	Reserved dd ?
ResDataEntry ENDS
; MACROS START
align_4 MACRO reg
	add reg, 3
	shr reg, 2
	shl reg, 2
ENDM



replaceRes PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

.data
	NUM_xx dd 3 dup (0) ; 1 - number, 0 - string
	MEM_xx dd 3 dup (0)
	ACT_xx dd 3 dup (0) ; 1 - add;    0 - replace (resource)
	OFFS_x dd 3 dup (0) ; FILE OFFSET WHERE NEW ID/LANG/DATA    SHOULD GO (if such doesn't exist)
	YYYY_x dd 3 dup (0)
	
.code

replaceRes proc uses ebx f_name:DWORD, resType:DWORD, resId:DWORD, resLang:DWORD, memNewRes:DWORD, sizeNewRes:DWORD
	LOCAL fileX:DWORD
	LOCAL  pMap:DWORD
	LOCAL  hMap:DWORD
	;LOCAL buf[128]:BYTE
	LOCAL OFFS:DWORD
	LOCAL OFFS_header0:DWORD
	LOCAL OFFS_header1:DWORD
	LOCAL OFFS_header2:DWORD
	LOCAL DIR_offs :DWORD
	LOCAL DIR_ecx  :DWORD
	LOCAL SEC_size :DWORD ; SIZE OF |.RSRC| SECTION
	LOCAL fAlign   :DWORD ; FILE ALIGMENT (ALL SECTIONS SHOULD BE ALIGNED ACCOR. TO THIS VALUE)
	LOCAL sAlign   :DWORD ; SECTION ALIGMENT
	LOCAL LAST_offs:DWORD
	LOCAL LAST_size:DWORD
	LOCAL OURS_offs:DWORD
	LOCAL OURS_size:DWORD
	LOCAL FREE_size:DWORD ; HOW MUCH SPACE IN |.RSRC| IS NOT USED
	LOCAL INC_size:DWORD
	LOCAL deltaRawSize:DWORD
	
	;FILE SHOULD ALREADY HAVE [.rsrc] EVEN EMPTY
	;=====> CLOSE IF FILE IS OPENED
	invoke UnmapViewOfFile, pMapping
	invoke CloseHandle, hMapping
	fclose(file)
	;=====> FIND OUT IF resource type,id is number or string
	mov    ecx, OFFSET NUM_xx
	mov    DWORD PTR [ecx+0], 1
	mov    eax, resType
	test   eax, 80000000h
	jz     @F
	xor    eax, 80000000h
	mov    resType, eax
	mov    DWORD PTR [ecx+0], 0
  @@:
	mov    DWORD PTR [ecx+4], 1
	mov    eax, resId
	test   eax, 80000000h
	jz     @F
	xor    eax, 80000000h
	mov    resId, eax
	mov    DWORD PTR [ecx+4], 0
  @@:
	mov    DWORD PTR [ecx+8], 1
	
	mov    fileX, fopen(f_name)
	invoke CreateFileMapping, fileX, 0, PAGE_READONLY, 0, 0, 0
	.IF eax!=0
		mov    hMap, eax
		mov    pMap, FUNC(MapViewOfFile, hMap, FILE_MAP_READ, 0, 0, 0)
		; FIND OUT IF RESOURCE ALREADY EXISTS |begin|
		mov    ebx, IMAGE_DOS_HEADER.e_lfanew[eax]
		add    ebx, eax
		mov    OFFS_header0, ebx
		mov    ecx, IMAGE_NT_HEADERS.OptionalHeader.FileAlignment[ebx]
		mov    fAlign, ecx
		mov    ecx, IMAGE_NT_HEADERS.OptionalHeader.SectionAlignment[ebx]
		mov    sAlign, ecx
		xor    ecx, ecx
		mov     cx, IMAGE_NT_HEADERS.FileHeader.NumberOfSections[ebx]
		add    ebx, SIZEOF IMAGE_NT_HEADERS
		.WHILE ecx > 0
			.IF DWORD PTR IMAGE_SECTION_HEADER.Name1[ebx]+1 == 'crsr'
				.BREAK
			.ENDIF
			dec    ecx
			add    ebx, SIZEOF IMAGE_SECTION_HEADER
		.ENDW
		mov    ecx, IMAGE_SECTION_HEADER.SizeOfRawData[ebx]
		mov    SEC_size, ecx
		mov    ecx, IMAGE_SECTION_HEADER.VirtualAddress[ebx]
		mov    esi, IMAGE_SECTION_HEADER.PointerToRawData[ebx]
		sub    ecx, esi
		mov    OFFS, ecx
		add    esi, eax
		mov    ebx, esi
		; FIND OUT IF SUCH TYPE EXISTS
		xor    ecx, ecx
		mov     cx, ResDir.NumberOfNamedEntries[esi]
		add     cx, ResDir.NumberOfIdEntries[esi]
		add    esi, SIZEOF ResDir
		test   ecx, ecx
		jz     @INSERT_RES_TYPE
		mov    DIR_offs, esi
		mov    DIR_ecx,  ecx
		
		xor    eax, eax
		mov    edx, OFFSET MEM_xx
		mov    DWORD PTR [edx+0], eax
		mov    DWORD PTR [edx+4], eax
		mov    DWORD PTR [edx+8], eax
		mov    edx, OFFSET ACT_xx
		mov    DWORD PTR [edx+0], eax
		mov    DWORD PTR [edx+4], eax
		mov    DWORD PTR [edx+8], eax
		mov    edx, OFFSET OFFS_x
		mov    DWORD PTR [edx+0], eax
		mov    DWORD PTR [edx+4], eax
		mov    DWORD PTR [edx+8], eax
		mov    edx, OFFSET YYYY_x
		mov    eax, resType
		mov    DWORD PTR [edx+0], eax
		mov    eax, resId
		mov    DWORD PTR [edx+4], eax
		mov    eax, resLang
		mov    DWORD PTR [edx+8], eax
			
		xor    edx, edx
			
	@enum_next:
		mov    edi, ResDirEntry.NameRVA[esi]
		cmp    DWORD PTR [NUM_xx+edx*4], 1
		jz     @TEST_NUM
	  @TEST_STR:
	  	test   edi, 80000000h
		jz     @F
		xor    edi, 80000000h
		jmp    @CMP_STR
	  @TEST_NUM:
	  	test   edi, 80000000h
		jnz    @F
		jmp    @CMP_NUM
	  @CMP_STR:
		push   edx
		push   ecx
		push   ebx
		invoke lstrcmp, DWORD PTR [YYYY_x+edx*4], edi
		pop    ebx
		pop    ecx
		pop    edx
		cmp    eax, 0
		jg     @INSERT
		jz     @ADD
		jmp    @F
	  @CMP_NUM:
		cmp    edi, DWORD PTR [YYYY_x+edx*4]
		ja     @INSERT
		jz     @ADD
	  @@:
		dec    ecx
		test   ecx, ecx
		jz     @done_enum
		add    esi, SIZEOF ResDirEntry
		jmp    @enum_next
	  @ADD:     ; REPLACEMENT
		mov    DWORD PTR [ACT_xx+edx*4], 1
	  @INSERT:  ; INSERTION
		mov    eax, ResDirEntry.DataEntry[esi]
		mov    edi, eax
		xor    eax, 80000000h
		mov    DWORD PTR [OFFS_x+edx*4], eax
	  @@:
		add    esi, sizeof ResDirEntry
		dec    ecx
		test   ecx, ecx
		jz     @done_enum
		jmp    @B
	@done_enum:
		inc    edx
		cmp    edx, 3
		jz     @over
		mov    esi, DWORD PTR [OFFS_x+(edx-1)*4]
		add    esi, ebx
		xor    ecx, ecx
		mov     cx, ResDir.NumberOfNamedEntries[esi]
		add     cx, ResDir.NumberOfIdEntries[esi]
		add    esi, SIZEOF ResDir
		jmp    @enum_next
	@over:
		cmp    DWORD PTR [ACT_xx+2*4], 1
		jnz    @F
		push   edi
		@@:
			
		mov    ecx, DWORD PTR [OFFS_x+2*4]
		xor    ecx, 80000000h
		add    ecx, ebx
		mov    eax, ResDataEntry.DataSize[ecx]
		mov    ecx, ResDataEntry.DataRVA[ecx]
		sub    ecx, OFFS
		mov    OURS_offs, ecx
		mov    OURS_size, eax
		
	;--- FIND OFFSET+SIZE TO RAW DATA OF LAST RESOURCE (SO WE KNOW HOW MUCH MORE SPACE WE HAVE)	
		mov    eax, OFFS_header0
		mov    edx, IMAGE_NT_HEADERS.OptionalHeader.DataDirectory.isize[eax]+2*(SIZEOF IMAGE_DATA_DIRECTORY)
		add    edx, ebx
		sub    edx, pMap
		mov    LAST_offs, edx
	;--- 	
		
		mov    eax, SEC_size
		add    eax, ebx
		sub    eax, LAST_offs
		sub    eax, pMap
		mov    FREE_size, eax
		
		; MEMORY MOVEMENT SHOULD BE DWORD ALIGNED
		
		mov    eax, OURS_size
		add    eax, FREE_size
		
		xor    ecx, ecx
	  @@:
		add    eax, ecx
		cmp    eax, sizeNewRes
		jae    @F
		add    ecx, fAlign
		jmp    @B
	  @@:
		mov    INC_size, ecx
		
		invoke UnmapViewOfFile, pMap
		invoke CloseHandle,     hMap
	.ENDIF
	fclose(fileX)
		
	mov    fileX, fopen(f_name)
		
	invoke GetFileSize, fileX, 0
	add    eax, INC_size
		
	invoke CreateFileMapping, fileX, 0, PAGE_READWRITE, 0, eax, 0
	.IF eax!=0
		mov    hMap, eax
		mov    pMap, FUNC(MapViewOfFile, hMap, FILE_MAP_READ+FILE_MAP_WRITE, 0, 0, 0)
		mov    ebx, IMAGE_DOS_HEADER.e_lfanew[eax]
		add    ebx, eax
		mov    OFFS_header1, ebx
		xor    ecx, ecx
		mov     cx, IMAGE_NT_HEADERS.FileHeader.NumberOfSections[ebx]
		add    ebx, SIZEOF IMAGE_NT_HEADERS 
		.WHILE ecx > 0
			.IF DWORD PTR IMAGE_SECTION_HEADER.Name1[ebx]+1 == 'crsr'
				.BREAK
			.ENDIF
			dec    ecx
			add    ebx, SIZEOF IMAGE_SECTION_HEADER
		.ENDW
		mov    OFFS_header2, ebx
		mov    ecx, IMAGE_SECTION_HEADER.VirtualAddress[ebx]
		mov    esi, IMAGE_SECTION_HEADER.PointerToRawData[ebx]
		sub    ecx, esi
		mov    OFFS, ecx
		add    esi, eax
		mov    ebx, esi
		;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
		; AT THIS POINT FILE IS ALREADY INCREASED IF NEEDED
		; WE KNOW EXACT PLACE WHERE NEW RESOURCE WILL BE INSERTED
		
		mov    ecx, OURS_size
		cmp    ecx, sizeNewRes
		jae    @no_move ; IF SIZE OF NEW RESOURCE IS BIGGER THAN THE SIZE OF OLD ONE
		  mov    ecx, sizeNewRes
		  sub    ecx, OURS_size
		  align_4 ecx
		  mov    deltaRawSize, ecx
		  mov    eax, LAST_offs
		  mov    edx, OURS_offs
		  sub    eax, edx
		  ;--------------------
		  add    edx, pMap
		  add    ecx, edx
		  invoke RtlMoveMemory, ecx, edx, eax
		  pop    esi
		  add    esi, ebx
		  mov    eax, sizeNewRes
		  mov    ResDataEntry.DataSize[esi], eax
		  ;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
		  
		  mov    esi, ebx
		  push   13  ; KAPUT
		  push   esi ; root address
	  @A1:
		  pop    esi ; retrieve directory address
		  cmp    esi, 13 ; IS IT KAPUT ?
		  jz     @A3
		  xor    ecx, ecx
		  mov    cx, ResDir.NumberOfNamedEntries[esi]
		  add    cx, ResDir.NumberOfIdEntries[esi] ; number of entries in directory
		  add    esi, sizeof ResDir
	  @@:
		  cmp    ecx, 0
		  jz     @A1            ; go or not to go to new directory
		  mov    edx, ResDirEntry.DataEntry[esi]
		  add    esi, sizeof ResDirEntry
		  dec    ecx
		  test   edx, 80000000h ; is hi-bit set ?
		  jnz    @A2
		  ;^^^^^^^^^^^^^^^^^^^^^^
		  add    edx, ebx
		  mov    eax, ResDataEntry.DataRVA[edx]
		  sub    eax, OFFS
		  cmp    eax, OURS_offs
		  jbe    @NO_CHANGE
		  add    eax, deltaRawSize
		  add    eax, OFFS
		  mov    ResDataEntry.DataRVA[edx], eax
		@NO_CHANGE:
		  ;^^^^^^^^^^^^^^^^^^^^^^
		  jmp    @B
	  @A2:
		  xor    edx, 80000000h ; clear hi-bit
		  add    edx, ebx       ; offset + root
		  push   edx            ; save address for future visits
		  jmp    @B
	  @A3: 	  
			
			mov    eax, OFFS_header1
		;	mov    ecx, IMAGE_NT_HEADERS.OptionalHeader.SizeOfImage[eax]
		;	add    ecx, INC_size
		;	memalign ecx, sAlign
		;	mov    IMAGE_NT_HEADERS.OptionalHeader.SizeOfImage[eax], ecx
			mov    edx, IMAGE_NT_HEADERS.OptionalHeader.DataDirectory.isize[eax]+2*(SIZEOF IMAGE_DATA_DIRECTORY)
			add    edx, deltaRawSize
			mov    IMAGE_NT_HEADERS.OptionalHeader.DataDirectory.isize[eax]+2*(SIZEOF IMAGE_DATA_DIRECTORY), edx
			mov    eax, OFFS_header2
			mov    ecx, IMAGE_SECTION_HEADER.SizeOfRawData[eax]
			add    ecx, INC_size
			mov    IMAGE_SECTION_HEADER.SizeOfRawData[eax], ecx
			mov    ecx, IMAGE_SECTION_HEADER.VirtualSize[eax]
			add    ecx, deltaRawSize
			mov    IMAGE_SECTION_HEADER.VirtualSize[eax], ecx
		  ;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
		@no_move:
		mov    ecx, OURS_offs
		add    ecx, pMap
		invoke MemCopy, memNewRes, ecx, sizeNewRes
		
		
	;	invoke dwtoa, FREE_size, ADDR buf
	;	invoke MessageBox, 0, ADDR buf, 0, MB_OK
	;	cmp    LANG_act, 1
	;	jz     @INSERT_RES_LANG
	;	cmp    ID_act,   1
	;	jz     @INSERT_RES_ID
	;	cmp    TYPE_act, 1
	;	jz     @INSERT_RES_TYPE
			
			
			
		;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
			
			
	  @INSERT_RES_TYPE:
			
		jmp    @INSERT_DONE
	  @INSERT_RES_ID:
			
		jmp    @INSERT_DONE
	  @INSERT_RES_LANG:
			
		jmp    @INSERT_DONE
	  @INSERT_DONE:
			
			
		invoke UnmapViewOfFile, pMap
		invoke CloseHandle,     hMap
	.ENDIF
	fclose(fileX)
		
	ret
replaceRes endp
